# DFF -- An Open Source Digital Forensics Framework
# Copyright (C) 2009-2010 ArxSys
# This program is free software, distributed under the terms of
# the GNU General Public License Version 2. See the LICENSE file
# at the top of the source tree.
#  
# See http://www.digital-forensic.org for more information about this
# project. Please do not directly contact any of the maintainers of
# DFF for assistance; the project provides a web site, mailing lists
# and IRC channels for your use.
# 
# Author(s):
#  Jeremy Mounier <jmo@digital-forensic.org>
# 

import sys

class GenerateCode():
    def __init__(self):
        pass
    
    def set_header(self, fname, lname, mail):
        self.fname = fname
        self.lname = lname
        self.mail = mail

    def generate_header(self):
        buff="# DFF -- An Open Source Digital Forensics Framework\n\
#\n\
# This program is free software, distributed under the terms of\n\
# the GNU General Public License Version 2. See the LICENSE file\n\
# at the top of the source tree.\n\
# \n\
# See http://www.digital-forensic.org for more information about this\n\
# project. Please do not directly contact any of the maintainers of\n\
# DFF for assistance; the project provides a web site, mailing lists\n\
# and IRC channels for your use.\n\
# \n\
# Author(s):\n\
#  " + self.fname + " "+ self.lname +" < " + self.mail + ">\n\
#\n\
\n"
        return buff

    def generate_script(self,  scriptname):
        buff = self.generate_header()
        buff += "from api.vfs import *\n\
from api.module.module import *\n\
\n\
class " + scriptname.upper() + "(Script):\n\
    def __init__(self):\n\
	#Module init stuff goes here\n\
	Script.__init__(self, \"" + scriptname + "\")\n\
\n\
    def c_display(self):\n\
	#You can add console display function here\n\
	#like ncurses func or others display func\n\
	#ex: print \"buff\"\n\
	pass\n\
\n\
    def start(self, args):\n\
        #get your arg here, ex : args.get_node('filename')\n\
        #do some stuff, ex: print \"Hello\"\n\
	#you can set your state too, ex : self.stateinfo = \"Processing file\"\n\
        #return your result, ex: self.res.add_const(\"result\", \"no problem\")\n\
        print \"Hello World !\"\n\
\n\
\n\
class " + scriptname + "(Module):\n\
  def __init__(self):\n\
    Module.__init__(self, \"" + scriptname + "\", " + scriptname.upper() + ")\n\
    #Add your argument and tags here\n\
    #First two parameters are mandatory, last two are optionals\n\
    # <argument name (string)>, <argument type (string)>, <argument is optional (bool)>, <argument description (string)>\n\
    #self.conf.add(\"filename\", \"node\")\n\
    #self.conf.add(\"algorithm\", \"string\", True, \"Sample argument string\")\n\
    #Add your const here, type of file handled by your module.\n\
    #self.conf.add_const(\"mime-type\", \"JPEG\")\n\
    #Tags specify the parent/menu directory of your module.\n\
    #self.tags = \"test\"\n"
        return buff

    def generate_script_gui(self,  scriptname):
        buff = self.generate_header()
	buff += "from PyQt4 import QtCore, QtGui\n\
from PyQt4.QtCore import *\n\
from PyQt4.QtGui import *\n\
from api.module.module import *\n\
\n\
class " + scriptname.upper() + "(QTextEdit, Script):\n\
    def __init__(self):\n\
	#Module init stuff goes here\n\
	Script.__init__(self, \"" + scriptname + "\")\n\
\n\
    def c_display(self):\n\
	#You can add console display function here\n\
	#like ncurses func or others display func\n\
	print self.buff\n\
\n\
    def g_display(self):\n\
	#This function must init a QWidget\n\
	QTextEdit.__init__(self, None)\n\
        self.append(self.buff)\n\
\n\
\n\
    def updateWidget(self):\n\
	#you can put your refresh on resize func here\n\
	pass\n\
\n\
    def start(self, args):\n\
        #get your arg here, ex : args.get_node('filename')\n\
        #do some stuff, ex: print \"Hello\"\n\
	#you can set your state too, ex : self.stateinfo = \"Processing file\"\n\
        #return your result, ex: self.res.add_const(\"result\", \"no problem\")\n\
	self.buff = \"Hello world !\"\n\
\n\
class " + scriptname + "(Module):\n\
  def __init__(self):\n\
    Module.__init__(self, \"" + scriptname + "\"," + scriptname.upper() + ")\n\
    #Add your argument and tags here\n\
    #self.conf.add(\"filename\", \"node\")\n\
    #self.tags = \"test\"\n"
        return buff	


    def generate_drivers(self,  drivername):
        buff = self.generate_header()
        buff += "from api.vfs import vfs\n\
from api.module.module import Module\n\
from api.type.libtype import vtime\n\
from api.vfs.libvfs import FdManager, fdinfo, Node, mfso\n\
from api.exceptions.libexceptions import vfsError\n\
from api.variant.libvariant import Variant\n\
\n\
class " + drivername + "(Module):\n\
  def __init__(self):\n\
     Module.__init__(self, \"" + drivername + "\", " + drivername.upper() +")\n\
     self.conf.add(\"parent\", \"node\")\n\
     self.tags = \"fs\"\n\
\n\
\n\
class " + drivername.upper() + "(mfso):\n\
   def __init__(self):\n\
      mfso.__init__(self, \"" + drivername + "\")\n\
      self.vfs = vfs.vfs()\n\
      #you can use fdmanager\n\
      #self.fdm = FdManager()\n\
      self.parent = None\n\
      self.res.add_const(\"result\", \"initialized\")\n\
    \n\
   def start(self, args):\n\
      self.parent = args.get_node('parent')\n\
      # old style root = self.CreateNodeFile(self.parent, name, attr)\n\
      self.res.add_const(\"result\", \"done\")\n\
\n\
   def vopen(self, node):\n\
      fd = 0\n\
      print 'Trying to open', node.absolute()\n\
      return fd\n\
    \n\
   def vread(self, fd, buff, size):\n\
      #return a tuple (size, buffer) where size is the number of bytes read\n\
      #on error raise a vfsError\n\
      buff = \"Hello world !\"\n\
      return (len(buff), buff)\n\
    \n\
   def vseek(self, fd,  offset, whence):\n\
      #return -1 for error or new offset position\n\
      return 0\n\
    \n\
   def vwrite(self, fd,  buff, size):\n\
      #raise a vfsError if you don't use this functions (forensic drivers)\n\
      raise vfsError(\"Can't write\")\n\
    \n\
   def vclose(self, fd):\n\
      #return 0 on success\n\
      return 0\n\
    \n\
\n"
     
        return buff
